> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.getkard.com/2024-10-01/api/users/create/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.getkard.com/_mcp/server. # Create Users POST https://rewards-api.getkard.com/v2/issuers/{organizationId}/users Content-Type: application/json Call this endpoint to enroll a specified user into your rewards program. Required scopes:  `user:write` Note: `Maximum of 100 users can be created per request`. Reference: https://docs.getkard.com/api/users/create ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Servers - `https://rewards-api.getkard.com` (Production, default) - `https://test-rewards-api.getkard.com` (Sandbox) ## Request ### Path parameters - `organizationId` (string, required) — Your issuer organization ID, provided by Kard ### Body (application/json) This endpoint expects a CreateUsersObject. - `data` (list of UserRequestDataUnion, required) ## Response ### 201 - `data` (list of UserRequestDataUnion, required) ## Errors ### 207 Multi Status - `errors` (list of ErrorObject, required) - `data` (list of UserRequestDataUnion, optional) ### 401 Unauthorized Error - `errors` (list of ErrorObject, required) ### 400 Invalid Request - `errors` (list of ErrorObject, required) ### 500 Internal Server Error - `errors` (list of ErrorObject, required) ### 409 Conflict Error - `errors` (list of ErrorObject, required) ## Types ### UserRequestDataUnion - `type`: `user` - `attributes` (UserRequestAttributes, required) - `id` (string, required) — The ID of the user as defined on the issuers system ### ErrorObject - `status` (string, required) — Status code returned from the request - `title` (string, required) — Name of error - `detail` (string, required) — Description of the specific occurance of the error - `source` (ErrorSource, optional) — An object containing a reference to the primary source of the error - `id` (string, optional) — The id of the resource which caused the error. Always returned for multi-status errors. ### UserRequestAttributes - `enrolledRewards` (list of enum, required) — Rewards programs to enroll the user in. If an empty array is supplied, the user will not be enrolled in any programs. - Allowed values: `CARDLINKED` - `zipCode` (string, optional) — Zipcode of user - `email` (string, optional) — Email address of user - `hashedEmail` (string, optional) — Hashed email address of user (using SHA-256) - `phoneNumber` (string, optional) — Phone number of user in E.164 format - `birthYear` (string, optional) — Birth year of user - `historicalTransactionsSent` (boolean, optional) — Indicates whether historical transactions have been sent for this user ### ErrorSource - `pointer` (string, optional) — A JSON pointer to the value in the request document that caused the error - `parameter` (string, optional) — A string indicating which URI query parameter caused the error - `header` (string, optional) — A string indicating the name of a single request header which caused the error ## Examples ### Example 1 **Request** ```json { "data": [ { "type": "user", "attributes": { "enrolledRewards": [ "CARDLINKED" ], "zipCode": "11238", "email": "user@example.com", "hashedEmail": "a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1", "phoneNumber": "+14155552671", "birthYear": "1990", "historicalTransactionsSent": true }, "id": "1234567890" } ] } ``` **Response** ```json { "data": [ { "type": "user", "attributes": { "enrolledRewards": [ "CARDLINKED" ], "zipCode": "11238", "email": "user@example.com", "hashedEmail": "a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1", "phoneNumber": "+14155552671", "birthYear": "1990", "historicalTransactionsSent": true }, "id": "1234567890" } ] } ``` **SDK Code** ```python import requests url = "https://rewards-api.getkard.com/v2/issuers/organization-123/users" payload = { "data": [ { "type": "user", "attributes": { "enrolledRewards": ["CARDLINKED"], "zipCode": "11238", "email": "user@example.com", "hashedEmail": "a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1", "phoneNumber": "+14155552671", "birthYear": "1990", "historicalTransactionsSent": True }, "id": "1234567890" } ] } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://rewards-api.getkard.com/v2/issuers/organization-123/users'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"data":[{"type":"user","attributes":{"enrolledRewards":["CARDLINKED"],"zipCode":"11238","email":"user@example.com","hashedEmail":"a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1","phoneNumber":"+14155552671","birthYear":"1990","historicalTransactionsSent":true},"id":"1234567890"}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://rewards-api.getkard.com/v2/issuers/organization-123/users" payload := strings.NewReader("{\n \"data\": [\n {\n \"type\": \"user\",\n \"attributes\": {\n \"enrolledRewards\": [\n \"CARDLINKED\"\n ],\n \"zipCode\": \"11238\",\n \"email\": \"user@example.com\",\n \"hashedEmail\": \"a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1\",\n \"phoneNumber\": \"+14155552671\",\n \"birthYear\": \"1990\",\n \"historicalTransactionsSent\": true\n },\n \"id\": \"1234567890\"\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://rewards-api.getkard.com/v2/issuers/organization-123/users") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"data\": [\n {\n \"type\": \"user\",\n \"attributes\": {\n \"enrolledRewards\": [\n \"CARDLINKED\"\n ],\n \"zipCode\": \"11238\",\n \"email\": \"user@example.com\",\n \"hashedEmail\": \"a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1\",\n \"phoneNumber\": \"+14155552671\",\n \"birthYear\": \"1990\",\n \"historicalTransactionsSent\": true\n },\n \"id\": \"1234567890\"\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://rewards-api.getkard.com/v2/issuers/organization-123/users") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"data\": [\n {\n \"type\": \"user\",\n \"attributes\": {\n \"enrolledRewards\": [\n \"CARDLINKED\"\n ],\n \"zipCode\": \"11238\",\n \"email\": \"user@example.com\",\n \"hashedEmail\": \"a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1\",\n \"phoneNumber\": \"+14155552671\",\n \"birthYear\": \"1990\",\n \"historicalTransactionsSent\": true\n },\n \"id\": \"1234567890\"\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://rewards-api.getkard.com/v2/issuers/organization-123/users', [ 'body' => '{ "data": [ { "type": "user", "attributes": { "enrolledRewards": [ "CARDLINKED" ], "zipCode": "11238", "email": "user@example.com", "hashedEmail": "a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1", "phoneNumber": "+14155552671", "birthYear": "1990", "historicalTransactionsSent": true }, "id": "1234567890" } ] }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://rewards-api.getkard.com/v2/issuers/organization-123/users"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"data\": [\n {\n \"type\": \"user\",\n \"attributes\": {\n \"enrolledRewards\": [\n \"CARDLINKED\"\n ],\n \"zipCode\": \"11238\",\n \"email\": \"user@example.com\",\n \"hashedEmail\": \"a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1\",\n \"phoneNumber\": \"+14155552671\",\n \"birthYear\": \"1990\",\n \"historicalTransactionsSent\": true\n },\n \"id\": \"1234567890\"\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = ["data": [ [ "type": "user", "attributes": [ "enrolledRewards": ["CARDLINKED"], "zipCode": "11238", "email": "user@example.com", "hashedEmail": "a94a8fe5ccb19ba61c4c0873d391e987982fbbd3e2d8a5b76e45a1d4c4e2e3a1", "phoneNumber": "+14155552671", "birthYear": "1990", "historicalTransactionsSent": true ], "id": "1234567890" ] ]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://rewards-api.getkard.com/v2/issuers/organization-123/users")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ``` ### Example 2 **Request** ```json { "data": [ { "type": "user", "attributes": { "enrolledRewards": [ "CARDLINKED" ] }, "id": "string" } ] } ``` **Response** ```json { "data": [ { "type": "user", "attributes": { "enrolledRewards": [ "CARDLINKED" ], "zipCode": "string", "email": "string", "hashedEmail": "string", "phoneNumber": "string", "birthYear": "string", "historicalTransactionsSent": true }, "id": "string" } ], "errors": [ { "status": "string", "title": "string", "detail": "string", "source": { "pointer": "string", "parameter": "string", "header": "string" }, "id": "string" } ] } ``` **SDK Code** ```python import requests url = "https://rewards-api.getkard.com/v2/issuers/%3AorganizationId/users" payload = { "data": [ { "type": "user", "attributes": { "enrolledRewards": ["CARDLINKED"] }, "id": "string" } ] } headers = { "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```javascript const url = 'https://rewards-api.getkard.com/v2/issuers/%3AorganizationId/users'; const options = { method: 'POST', headers: {Authorization: 'Bearer ', 'Content-Type': 'application/json'}, body: '{"data":[{"type":"user","attributes":{"enrolledRewards":["CARDLINKED"]},"id":"string"}]}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://rewards-api.getkard.com/v2/issuers/%3AorganizationId/users" payload := strings.NewReader("{\n \"data\": [\n {\n \"type\": \"user\",\n \"attributes\": {\n \"enrolledRewards\": [\n \"CARDLINKED\"\n ]\n },\n \"id\": \"string\"\n }\n ]\n}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://rewards-api.getkard.com/v2/issuers/%3AorganizationId/users") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{\n \"data\": [\n {\n \"type\": \"user\",\n \"attributes\": {\n \"enrolledRewards\": [\n \"CARDLINKED\"\n ]\n },\n \"id\": \"string\"\n }\n ]\n}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://rewards-api.getkard.com/v2/issuers/%3AorganizationId/users") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{\n \"data\": [\n {\n \"type\": \"user\",\n \"attributes\": {\n \"enrolledRewards\": [\n \"CARDLINKED\"\n ]\n },\n \"id\": \"string\"\n }\n ]\n}") .asString(); ``` ```php request('POST', 'https://rewards-api.getkard.com/v2/issuers/%3AorganizationId/users', [ 'body' => '{ "data": [ { "type": "user", "attributes": { "enrolledRewards": [ "CARDLINKED" ] }, "id": "string" } ] }', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://rewards-api.getkard.com/v2/issuers/%3AorganizationId/users"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"data\": [\n {\n \"type\": \"user\",\n \"attributes\": {\n \"enrolledRewards\": [\n \"CARDLINKED\"\n ]\n },\n \"id\": \"string\"\n }\n ]\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = ["data": [ [ "type": "user", "attributes": ["enrolledRewards": ["CARDLINKED"]], "id": "string" ] ]] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://rewards-api.getkard.com/v2/issuers/%3AorganizationId/users")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```